% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/plot_exp_model.R
\name{plot_exp_model}
\alias{plot_exp_model}
\title{Bayesian exponential model using stan}
\usage{
plot_exp_model(
  X,
  Y,
  N,
  fit_exp,
  X_model,
  color_list = as.list(rep("red", length(X_model))),
  ylim = 2
)
}
\arguments{
\item{X}{date vector of data you want on the graph}

\item{Y}{Numeric vector of number of positive samples}

\item{N}{Numeric vector of total number of samples}

\item{fit_exp}{either fitted exponential model using reactidd::stan_exp_model() or list of such models}

\item{X_model}{the X data for the fittd model or a list() of the X data for the fitted models (length must match number of models given for 'fit_exp')}

\item{color_list}{list() of color characters defaults to list("red") of same length as number of models.}

\item{ylim}{sets the ylimit of the plot}
}
\value{
A ggplot of the exp model/models, the raw data and binomial CI's and the raw data of the model fits used in plotting (all in list format)
}
\description{
Bayesian exponential model using stan
}
